<template>
  <div class="px-8 mt-4 game-list-container">
    <header class="page__header">
      <h1 id="filter-title" class="page__title mb-2">{{ $t(gameTitle) }}</h1>
      <div class="page-games__controls">
        <div
          class="search__wrapper btn-search"
          data-search=""
          @click="openSearchModal"
        >
          <div class="search">
            <div id="btn-search" class="icon-search">
              <font-awesome-icon icon="search" />
            </div>
            <span class="search__placeholder">{{ $t("Search All Games") }}</span>
          </div>
        </div>
        <div class="select-provider">
          <GameProviderCategory
            :is-game-provider="true"
            :is-select-provider="true"
            :should-fix-z-index="true"
          />
        </div>
      </div>
    </header>
    <game-type-button />
    <no-data
      v-if="isLoading"
      :empty-text="$t('searching_game')"
    />
    <no-data v-if="!initialGameEntry?.length && !isLoading && activeTab !== 'favorite'"
      :empty-text="$t('no_game_found')"
    />
    <no-data v-if="!initialGameEntry?.length && !isLoading && activeTab === 'favorite'"
      :empty-text="$t('No game has been added to favorite.')"
    />
    <div v-else v-infinite-scroll="gameLoading" class="grid games__list">
      <GameEntry
        v-for="game in gameReadyToRender"
        :key="game.GameId"
        :game-data="game"
        tab-type="games"
        :check-is-favourite="checkIsFavourite"
        :set-and-unset-game-to-favourite="setAndUnsetGameToFavourite"
        :redirect-to-login="redirectToLogin"
      />
    </div>
    <el-backtop :right="30" :bottom="30">
      <div class="w-[35px] h-[35px] flex items-center justify-center">
        <font-awesome-icon icon="arrow-up" class="text-black" />
      </div>
    </el-backtop>
  </div>
  <SearchModal :is-open="isOpen" @close="closeSearchModal" />
</template>
<script lang="ts" setup>
import GameTypeButton from "./components/GameTypeButton.client.vue";
import GameEntry from "./components/gameComponents/GameEntry.client.vue";
import SearchModal from "./components/search-modal/SearchModal.client.vue";
import GameProviderCategory from "./components/GameProviderCategory.client.vue";
import NoData from "./components/NoData.client.vue";
import { useGameEntryComponent } from "@/composables/useTheme";
import { IGameBsi } from "@/models/bsiGameList";
const gameTitle = ref("top_games");
const isOpen = ref(false);
const route = useRoute();
const openSearchModal = () => {
  isOpen.value = true;
};
const closeSearchModal = () => {
  isOpen.value = false;
};
const {
  isLoading,
  filtered,
  gameTypes,
  authenticated,
  handleSelectedTabOption,
  initialGameEntry,
  activeTab,
} = useGameEntryComponent();
const {
  setAndUnsetGameToFavourite,
  checkIsFavourite,
  redirectToLogin,
} = useAddToFavorite();
const checkIsGameType = (params: string) => gameTypes.value.includes(params);
function checkGameType() {
  if (filtered.value === "") {
    if (!authenticated) {
      handleSelectedTabOption(gameTypes.value[0]);
    }
  } else {
    const game = String(filtered.value.slice(0, -7));
    gameTitle.value = game;
    const isGameType = checkIsGameType(game);
    if (game === "HotGames" || game === "NewGames" || game === "Favorite") {
      handleSelectedTabOption(game);
    } else {
      handleSelectedTabOption(isGameType ? "GameType" : "provider", game);
    }
  }
}
checkGameType();

watch(
  () => route.params.filter,
  () => {
    if (route.params.filter !== undefined) {
      filtered.value = route.params.filter;
      checkGameType();
    }
  }
);
const gameReadyToRender = ref<Array<IGameBsi> | undefined>([]);
const index = ref(0);
const gameRender = computed(() => {
  const chunkSize = 33;
  const games = [];
  if (initialGameEntry.value !== undefined) {
    for (let i = 0; i < initialGameEntry.value.length; i += chunkSize) {
      const chunk: Array<IGameBsi> | undefined = initialGameEntry.value.slice(
        i,
        i + chunkSize
      );
      games.push(chunk);
    }
  }
  return games;
});
const gameRenderer = () => {
  gameRender.value[index.value].forEach((item) => {
    gameReadyToRender.value?.push(item);
  });
};
watch(gameRender, () => {
  gameReadyToRender.value = [];
  index.value = 0;
  if (gameRender.value.length) {
    gameRenderer();
  }
});
const gameLoading = () => {
  index.value += 1;
  if (index.value < gameRender.value.length) {
    gameRenderer();
  }
};
</script>
<style lang="scss" scoped>
.games__list {
  grid-template-columns: repeat(8, 1fr);
}
.page__header {
  position: relative;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: justify;
  -ms-flex-pack: justify;
  justify-content: space-between;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  -ms-flex-wrap: wrap;
  flex-wrap: wrap;
  margin-bottom: 40px;
  @media (max-width: 1220px) {
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -ms-flex-direction: column;
    flex-direction: column;
    -webkit-box-align: start;
    -ms-flex-align: start;
    align-items: flex-start;
  }
  .page__title {
    width: auto;
    margin: 0;
    font-size: 44px;
    line-height: 52px;
    font-style: normal;
    font-weight: 700;
    -webkit-transition: color 0.4s;
    transition: color 0.4s;
    color: var(--title-font-color);
    @media (max-width: 1220px) {
      -webkit-box-orient: vertical;
      -webkit-box-direction: normal;
      flex-direction: column;
      -webkit-box-align: start;
      align-items: flex-start;
    }
  }
  .page-games__controls {
    display: flex;
    gap: 1rem;
    @media (max-width: 767px) {
      flex-wrap: wrap;
      -webkit-box-pack: justify;
      -ms-flex-pack: justify;
      justify-content: space-between;
      width: 100%;
    }
    .search__wrapper {
      width: 360px;
      margin-bottom: 0;
      position: relative;
      height: 40px;
      .search {
        display: flex;
        -webkit-box-align: center;
        align-items: center;
        background-color: var(--button-bg);
        border-radius: 8px;
        box-shadow: var(--box-shadow-inset);
        .icon-search {
          width: 40px;
          height: 40px;
          font-size: 16px;
          flex-shrink: 0;
          color: var(--font-color-primary);
          display: flex;
          align-items: center;
          justify-content: center;
        }
        .search__placeholder {
          color: var(--font-color-primary);
          opacity: 1;
          visibility: visible;
          text-indent: 0;
        }
      }
    }
  }
}
:deep(.games-providers__toggle) {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  height: 40px;
  font-size: 14px;
  line-height: 20px;
  padding: 0 16px;
  background: var(--button-bg);
  border: 1px solid var(--element-border-color);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 8px;
  cursor: pointer;
}
</style>
